import * as i0 from '@angular/core';
import { Injectable, Component, ChangeDetectionStrategy, Input, EventEmitter, Output, NgModule } from '@angular/core';
import * as i5 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i7 from '@angular/forms';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i2$2 from 'ng-zorro-antd/grid';
import { NzGridModule } from 'ng-zorro-antd/grid';
import * as i3 from 'ng-zorro-antd/button';
import { NzButtonModule } from 'ng-zorro-antd/button';
import * as i9$1 from 'ng-zorro-antd/icon';
import { NzIconModule } from 'ng-zorro-antd/icon';
import { finalize, debounceTime, distinctUntilChanged } from 'rxjs/operators';
import * as i1 from 'ng-zorro-antd/input';
import { NzInputModule } from 'ng-zorro-antd/input';
import * as i3$1 from 'ng-zorro-antd/spin';
import { NzSpinModule } from 'ng-zorro-antd/spin';
import * as i4$1 from 'ng-zorro-antd/table';
import { NzTableModule } from 'ng-zorro-antd/table';
import * as i2 from 'ng-zorro-antd/switch';
import { NzSwitchModule } from 'ng-zorro-antd/switch';
import * as i4 from 'ng-zorro-antd/dropdown';
import { NzDropDownModule } from 'ng-zorro-antd/dropdown';
import * as i9 from 'ng-zorro-antd/core/wave';
import * as i8 from 'ng-zorro-antd/core/transition-patch';
import * as i10 from 'ng-zorro-antd/menu';
import { NzPaginationModule } from 'ng-zorro-antd/pagination';
import * as i8$1 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i1$1 from 'ng-zorro-antd/page-header';
import { NzPageHeaderModule } from 'ng-zorro-antd/page-header';
import * as i6 from 'ng-zorro-antd/tabs';
import { NzTabsModule } from 'ng-zorro-antd/tabs';
import * as i2$1 from 'ng-zorro-antd/breadcrumb';
import { NzBreadCrumbModule } from 'ng-zorro-antd/breadcrumb';
import * as i3$2 from 'ng-zorro-antd/tag';
import { NzTagModule } from 'ng-zorro-antd/tag';
import { NzAnchorModule } from 'ng-zorro-antd/anchor';
import { NzCardModule } from 'ng-zorro-antd/card';
import { NzCascaderModule } from 'ng-zorro-antd/cascader';
import { NzCollapseModule } from 'ng-zorro-antd/collapse';
import { NzDividerModule } from 'ng-zorro-antd/divider';
import { NzDrawerModule } from 'ng-zorro-antd/drawer';
import { NzFormModule } from 'ng-zorro-antd/form';
import { NzInputNumberModule } from 'ng-zorro-antd/input-number';
import { NzMessageModule } from 'ng-zorro-antd/message';
import { NzModalModule } from 'ng-zorro-antd/modal';
import { NzRadioModule } from 'ng-zorro-antd/radio';
import { NzResultModule } from 'ng-zorro-antd/result';
import { NzSelectModule } from 'ng-zorro-antd/select';
import { NzSpaceModule } from 'ng-zorro-antd/space';
import { NzToolTipModule } from 'ng-zorro-antd/tooltip';
import { NzTypographyModule } from 'ng-zorro-antd/typography';
import { EditOutline, PlusOutline, DeleteOutline, WarningOutline } from '@ant-design/icons-angular/icons';

var ResponseStatus;
(function (ResponseStatus) {
    ResponseStatus["Success"] = "SUCCESS";
    ResponseStatus["Failed"] = "FAILED";
})(ResponseStatus || (ResponseStatus = {}));

class UmbrellaLibraryService {
    constructor() { }
    isSuccessfulResponse(response) {
        return response.responseStatus === 'SUCCESS';
    }
}
UmbrellaLibraryService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
UmbrellaLibraryService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class UmbrellaLibraryComponent {
    constructor() { }
    ngOnInit() { }
}
UmbrellaLibraryComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
UmbrellaLibraryComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: UmbrellaLibraryComponent, selector: "lib-umbrella-library", ngImport: i0, template: ` <p>umbrella-library is amazing!</p> `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-umbrella-library',
                    template: ` <p>umbrella-library is amazing!</p> `,
                    styles: [],
                }]
        }], ctorParameters: function () { return []; } });

var DataTableColumnFormatType;
(function (DataTableColumnFormatType) {
    DataTableColumnFormatType["date"] = "date";
    DataTableColumnFormatType["boolean"] = "boolean";
    DataTableColumnFormatType["label"] = "label";
    DataTableColumnFormatType["statusToggle"] = "statusToggle";
    DataTableColumnFormatType["nestedAttribute"] = "nestedAttribute";
    DataTableColumnFormatType["menuDropdownActions"] = "menuDropdownActions";
    DataTableColumnFormatType["templateRef"] = "templateRef";
    DataTableColumnFormatType["contacts"] = "contacts";
})(DataTableColumnFormatType || (DataTableColumnFormatType = {}));

/**
 *
 * @param object a table data record
 * @param nestedAttributePath the path of a nested attribute to display
 * @returns the value of a sub object located at the nested path of the input object
 * @example
 * ```ts
 * const exObj = {fleet: {vehicleGroup: {id: 1, name: 'v group 1'}}};
 * const nestedValue = getNestedAttribute(exObj, 'fleet.vehicleGroup.name');
 * console.log(nestedValue);
 * // v group 1
 * ```
 */
function getNestedAttribute(object, nestedAttributePath) {
    const nestedAttributes = nestedAttributePath.split('.');
    let nestedAttributeValue = object;
    for (let nestedAttribute of nestedAttributes) {
        if (nestedAttributeValue[nestedAttribute]) {
            nestedAttributeValue = nestedAttributeValue[nestedAttribute];
        }
        else {
            nestedAttributeValue = undefined;
            break;
        }
    }
    return nestedAttributeValue;
}

class CustomDataTableCellComponent {
    constructor(cdr, library) {
        this.cdr = cdr;
        this.library = library;
        this.dataTableColumnFormatType = DataTableColumnFormatType;
        this.getNestedAttribute = getNestedAttribute;
    }
    onStatusToggleClick(event, column, record) {
        var _a;
        if (((_a = column.format) === null || _a === void 0 ? void 0 : _a.type) === DataTableColumnFormatType.statusToggle) {
            this.loadingStatusToggleRecordId = record.id;
            column.format
                .action(record.id, Object.assign(Object.assign({}, record), { status: !record.status }))
                .pipe(finalize(() => {
                this.loadingStatusToggleRecordId = -1;
                this.cdr.markForCheck();
            }))
                .subscribe((response) => {
                if (!this.library.isSuccessfulResponse(response)) {
                    event.preventDefault();
                }
                else {
                    record.status = !record.status;
                }
            });
        }
    }
}
CustomDataTableCellComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: CustomDataTableCellComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: UmbrellaLibraryService }], target: i0.ɵɵFactoryTarget.Component });
CustomDataTableCellComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: CustomDataTableCellComponent, selector: "x-custom-data-table-cell", inputs: { column: "column", record: "record" }, ngImport: i0, template: "<ng-container *ngIf=\"column.format\"\r\n    [ngSwitch]=\"column.format.type\">\r\n  <!-- Date -->\r\n  <span *ngSwitchCase=\"dataTableColumnFormatType.date\">\r\n    {{ record[column.field] | date: 'd MMM yyyy' }}\r\n  </span>\r\n  <!-- Boolean -->\r\n  <span *ngSwitchCase=\"dataTableColumnFormatType.boolean\">\r\n    {{ record[column.field] ? column.format.true : column.format.false }}\r\n  </span>\r\n  <!-- Label -->\r\n  <span *ngSwitchCase=\"'label'\">\r\n    <label\r\n        class=\"x-table-label x-table-label-{{ column.format.labels[record[column.field]].labelColor }}\">\r\n      {{ column.format.labels[record[column.field]].labelText }}\r\n    </label>\r\n  </span>\r\n  <!-- Contacts -->\r\n  <span *ngSwitchCase=\"dataTableColumnFormatType.contacts\">\r\n    <span *ngIf=\"!record[column.field].length\">\r\n      {{ record[column.field].firstName }}\r\n      {{ record[column.field].lastName }}\r\n    </span>\r\n    <span *ngFor=\"let c of record[column.field]; last as isLast\"\r\n        class=\"capitalize\">\r\n      {{ c.firstName }} {{ c.lastName }}<br *ngIf=\"!isLast\" />\r\n    </span>\r\n  </span>\r\n  <!-- Status -->\r\n  <nz-switch *ngSwitchCase=\"dataTableColumnFormatType.statusToggle\"\r\n      [nzLoading]=\"loadingStatusToggleRecordId === record.id\"\r\n      (click)=\"onStatusToggleClick($event, column, record)\"\r\n      [ngModel]=\"record.status\"></nz-switch>\r\n  <!-- Nested Attribute -->\r\n  <span *ngSwitchCase=\"dataTableColumnFormatType.nestedAttribute\">\r\n    {{ getNestedAttribute(record, column.field) }}\r\n  </span>\r\n  <!-- Edit, Delete and more Action Buttons -->\r\n  <ng-container *ngSwitchCase=\"dataTableColumnFormatType.menuDropdownActions\">\r\n    <div class=\"x-data-table-dropdown-menu-cell hidden\"\r\n        *ngIf=\"column.format?.dropdownActionItems?.length\">\r\n      <button nz-button\r\n          nzNoAnimation\r\n          nz-dropdown\r\n          [nzDropdownMenu]=\"menu\"\r\n          style=\"border: none; padding: 0\">\r\n        <i nz-icon\r\n            nzType=\"ellipsis\"\r\n            nzTheme=\"outline\"\r\n            style=\"font-size: 20px; vertical-align: top\">\r\n        </i>\r\n      </button>\r\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\r\n        <ul nz-menu>\r\n          <li *ngFor=\"let dropdownItem of column.format.dropdownActionItems\"\r\n              nz-menu-item\r\n              [nzDisabled]=\"dropdownItem.disabled\"\r\n              [ngClass]=\"{ 'no-pointer': dropdownItem.disabled }\"\r\n              (click)=\"dropdownItem.action(record)\">\r\n            <span>\r\n              <i nz-icon\r\n                  [nzType]=\"dropdownItem.nzIconName\"></i>\r\n              {{ dropdownItem.text }}\r\n            </span>\r\n          </li>\r\n        </ul>\r\n      </nz-dropdown-menu>\r\n    </div>\r\n  </ng-container>\r\n</ng-container>\r\n", styles: [".x-data-table-dropdown-menu-cell{display:inline-flex!important}.x-data-table-dropdown-menu-cell button{border:1.5px solid #00000026;width:32px}label.x-table-label{border-radius:15px;padding:5px 10px}label.x-table-label.x-table-label-red{background-color:var(--x-color-danger-surface);color:var(--x-color-danger-main)}label.x-table-label.x-table-label-green{background-color:var(--x-color-success-surface);color:var(--x-color-success-main)}label.x-table-label.x-table-label-gray{background-color:var(--x-color-neutral-focused);color:var(--x-color-neutral-main)}::ng-deep .no-pointer{pointer-events:none;cursor:default}\n"], components: [{ type: i2.NzSwitchComponent, selector: "nz-switch", inputs: ["nzLoading", "nzDisabled", "nzControl", "nzCheckedChildren", "nzUnCheckedChildren", "nzSize"], exportAs: ["nzSwitch"] }, { type: i3.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { type: i4.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i5.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i7.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i7.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i9.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i8.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i4.NzDropdownButtonDirective, selector: "[nz-button][nz-dropdown]" }, { type: i4.NzDropDownDirective, selector: "[nz-dropdown]", inputs: ["nzDropdownMenu", "nzTrigger", "nzMatchWidthElement", "nzHasBackdrop", "nzBackdrop", "nzClickHide", "nzDisabled", "nzVisible", "nzOverlayClassName", "nzOverlayStyle", "nzPlacement"], outputs: ["nzVisibleChange"], exportAs: ["nzDropdown"] }, { type: i9$1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { type: i10.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { type: i10.NzMenuItemDirective, selector: "[nz-menu-item]", inputs: ["nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter", "nzPaddingLeft"], exportAs: ["nzMenuItem"] }, { type: i5.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], pipes: { "date": i5.DatePipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: CustomDataTableCellComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'x-custom-data-table-cell',
                    templateUrl: './custom-data-table-cell.component.html',
                    styleUrls: ['./custom-data-table-cell.component.scss'],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: UmbrellaLibraryService }]; }, propDecorators: { column: [{
                type: Input
            }], record: [{
                type: Input
            }] } });

class DataTableComponent {
    constructor(cdr) {
        this.cdr = cdr;
        this.showDownload = false;
        this.downloadFile = 'Data_Table';
        this.totalRecordsCount = 0;
        this.pageSize = 10;
        this.loading = false;
        this.selectable = false;
        this.selectedRecordsSet = new Set();
        this.readonly = false;
        this.fetchRecords = new EventEmitter();
        this.selectRecord = new EventEmitter();
        this.dataTableColumnFormatType = DataTableColumnFormatType;
        this.PAGE_SIZE_OPTIONS = this.displaySizeOptions || [5, 10, 20, 50, 100];
        this.currentPageIndex = 1;
        this.searchControl = new FormControl('');
    }
    ngOnInit() {
        this._subscribeToSearchControlChanges();
    }
    ngOnChanges(changes) {
        var _a, _b;
        /** @TODO: check loading status. loading should be input */
        if (((_a = changes.records) === null || _a === void 0 ? void 0 : _a.currentValue) !== 'undefined' ||
            ((_b = changes.totalRecordsCount) === null || _b === void 0 ? void 0 : _b.currentValue) !== 'undefined') {
            this.loading = false;
        }
    }
    reset(force = false) {
        if (!force || this.currentPageIndex === 1) {
            this._fetchRecords();
        }
        else {
            this._resetPagination();
        }
    }
    clearSearch() {
        this.searchControl.setValue('');
        this.searchControl.updateValueAndValidity();
    }
    /* Handle Selection Checkboxes */
    updateCheckedSet(id, checked) {
        if (checked) {
            this.selectedRecordsSet.add(id);
        }
        else {
            this.selectedRecordsSet.delete(id);
        }
    }
    onAllChecked(checked) {
        this.records.forEach((rec) => this.updateCheckedSet(rec.id, checked));
        this.selectRecord.emit(this.selectedRecordsSet);
    }
    onItemChecked(id, checked) {
        this.updateCheckedSet(id, checked);
        this.selectRecord.emit(this.selectedRecordsSet);
    }
    onQueryParamsChange(params) {
        const { pageSize, pageIndex } = params;
        this.currentPageIndex = pageIndex;
        this.pageSize = pageSize;
        this._fetchRecords();
    }
    downloadCsv() {
        const header = this.columns.map((col) => col.name);
        const content = this.records.map((record) => {
            return this.columns.map((col) => record[col.field]).join(',');
        });
        const blob = new Blob([[header, ...content].join('\r\n')], { type: 'text/csv' });
        const tag = document.createElement('a');
        tag.href = URL.createObjectURL(blob);
        tag.target = '_blank';
        tag.download = `${this.downloadFile}.csv`;
        tag.click();
    }
    _subscribeToSearchControlChanges() {
        this.searchControl.valueChanges
            .pipe(debounceTime(300), distinctUntilChanged())
            .subscribe(() => {
            this.reset(this.currentPageIndex !== 1);
        });
    }
    _resetPagination() {
        this.currentPageIndex = 1;
        this.cdr.markForCheck();
    }
    _fetchRecords() {
        this.loading = true;
        this.fetchRecords.emit({
            searchKey: this.searchControl.value,
            /* @TODO Implement sorting or remove this */
            //sortOrder: this._getSortOrder(),
            //sortField: this.sortedColumn?.field,
            paginationInfo: { pageNumber: this.currentPageIndex, pageSize: this.pageSize },
        });
    }
}
DataTableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: DataTableComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
DataTableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: DataTableComponent, selector: "x-data-table", inputs: { columns: "columns", records: "records", showDownload: "showDownload", downloadFile: "downloadFile", displaySizeOptions: "displaySizeOptions", totalRecordsCount: "totalRecordsCount", pageSize: "pageSize", label: "label", loading: "loading", selectable: "selectable", selectedRecordsSet: "selectedRecordsSet", readonly: "readonly", customCellTemplateRef: "customCellTemplateRef" }, outputs: { fetchRecords: "fetchRecords", selectRecord: "selectRecord" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"x-table-card margin-24px\">\r\n  <div class=\"x-table-container\">\r\n    <div class=\"x-table-topbar\">\r\n      <nz-input-group class=\"x-table-search-input\"\r\n          attr.data-testid=\"{{ label + '-table-search' }}\"\r\n          [nzPrefix]=\"iconSearchTemplate\"\r\n          [nzSuffix]=\"inputClearTemplate\">\r\n        <input [formControl]=\"searchControl\"\r\n            type=\"text\"\r\n            nz-input\r\n            placeholder=\"Search...\" />\r\n      </nz-input-group>\r\n      <button *ngIf=\"showDownload\" attr.data-testid=\"{{ label + '-record-org-download' }}\"\r\n        nz-tooltip\r\n        nzTooltipTitle=\"Download CSV\"\r\n        nz-button\r\n        nzType=\"default\"\r\n        (click)=\"downloadCsv()\">\r\n        <i nz-icon\r\n          nzType=\"download\"></i>\r\n      </button>\r\n    </div>\r\n    <div *ngIf=\"loading\"\r\n        class=\"x-table-spinner\">\r\n      <nz-spin nzSimple\r\n          class=\"x-table-spinner-spinning\"\r\n          [nzIndicator]=\"indicatorTemplate\"></nz-spin>\r\n      <p>Loading...</p>\r\n    </div>\r\n    <div [class.x-table-loading]=\"loading\">\r\n      <div class=\"x-table\">\r\n        <nz-table attr.data-testid=\"{{ label + '-table' }}\"\r\n            #nzTable\r\n            [nzData]=\"records\"\r\n            [nzFrontPagination]=\"false\"\r\n            [nzTotal]=\"totalRecordsCount\"\r\n            [nzPageIndex]=\"currentPageIndex\"\r\n            [nzShowTotal]=\"rangeTemplate\"\r\n            nzShowSizeChanger\r\n            nzTableLayout=\"fixed\"\r\n            (nzQueryParams)=\"onQueryParamsChange($event)\">\r\n          <thead>\r\n            <tr>\r\n              <th *ngIf=\"selectable\"\r\n                  id=\"checkbox-header\"\r\n                  attr.qa-test-id=\"checkbox-header\"\r\n                  [nzShowCheckbox]=\"true\"\r\n                  (nzCheckedChange)=\"onAllChecked($event)\"\r\n                  [nzWidth]=\"'100px'\"\r\n                  [ngClass]=\"{'no-pointer': readonly}\"></th>\r\n              <ng-container *ngFor=\"let column of columns\">\r\n                <th [nzWidth]=\"column.width\"\r\n                    [class]=\"column.headerClass\">\r\n                  <!-- @TODO Implement sorting\r\n                  [nzSortFn]=\"column.sort\"\r\n                  [(nzSortOrder)]=\"column.sortOrder\"\r\n                  (nzSortOrderChange)=\"onSortingChanged(column)\">\r\n                  -->\r\n                  {{ column.name }}\r\n                </th>\r\n              </ng-container>\r\n            </tr>\r\n          </thead>\r\n\r\n          <tbody>\r\n            <tr *ngFor=\"let record of nzTable.data\">\r\n              <td *ngIf=\"selectable\"\r\n                  attr.qa-test-id=\"{{ 'checkbox-record' + record.id }}\"\r\n                  [nzChecked]=\"selectedRecordsSet.has(record.id)\"\r\n                  [nzShowCheckbox]=\"true\"\r\n                  (nzCheckedChange)=\"onItemChecked(record.id, $event)\"\r\n                  [ngClass]=\"{'no-pointer': readonly}\"></td>\r\n              <ng-container *ngFor=\"let column of columns\">\r\n                <!-- LOOP THROUGH DISPLAYED COLUMNS -->\r\n                <td [class]=\"column.cellClass\">\r\n                  <span *ngIf=\"!column.format\">{{ record[column.field] }}</span>\r\n\r\n                  <!-- HANDLE SPECIAL FORMATS -->\r\n                  <!-- As a custom template ref -->\r\n                  <ng-container *ngIf=\"\r\n                      customCellTemplateRef &&\r\n                      column.format?.type === dataTableColumnFormatType.templateRef\r\n                    \"\r\n                      [ngTemplateOutlet]=\"customCellTemplateRef\"\r\n                      [ngTemplateOutletContext]=\"{ column: column, record: record }\">\r\n                  </ng-container>\r\n                  <!-- Or one of most commonly used format type cases -->\r\n\r\n                  <x-custom-data-table-cell *ngIf=\"\r\n                      column.format && column.format?.type !== dataTableColumnFormatType.templateRef\r\n                    \"\r\n                      [column]=\"column\"\r\n                      [record]=\"record\">\r\n                  </x-custom-data-table-cell>\r\n                </td>\r\n              </ng-container>\r\n            </tr>\r\n          </tbody>\r\n        </nz-table>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n\r\n<ng-template #iconSearchTemplate>\r\n  <i class=\"x-table-search-icon\"\r\n      nz-icon\r\n      nzType=\"search\"></i>\r\n</ng-template>\r\n<ng-template #inputClearTemplate>\r\n  <i nz-icon\r\n      class=\"ant-input-clear-icon\"\r\n      nzTheme=\"fill\"\r\n      nzType=\"close-circle\"\r\n      *ngIf=\"searchControl.value\"\r\n      (click)=\"clearSearch()\"></i>\r\n</ng-template>\r\n\r\n<ng-template #indicatorTemplate><i nz-icon\r\n      nzType=\"loading\"></i></ng-template>\r\n\r\n<ng-template #rangeTemplate let-range=\"range\" let-total>\r\n  Showing {{ range[0] }} - {{ range[1] }} of {{ totalRecordsCount }} {{ label }}\r\n</ng-template>\r\n", styles: [".x-table-card{background:var(--x-color-neutral-surface);box-shadow:0 0 1px #0000001a,0 1px 3px #0000001f;border-radius:6px}.x-table-container .x-table-topbar{padding:24px;border-bottom:1px solid var(--x-color-border-normal);display:flex;justify-content:space-between}.x-table-container .x-table-topbar .fm-search-input{width:360px}.x-table-container .x-table-topbar .fm-search-input input::placeholder{color:var(--x-color-text-on-surface-subtle);font-style:italic}.x-table-container .x-table-topbar .x-table-search-icon{color:var(--x-color-text-on-surface-subtle);margin-right:6px}.x-table-container .x-table-topbar .x-table-download-button{padding:6px;margin-left:12px}.x-table-container .x-table-topbar .x-table-download-button x-svg-icon{color:var(--x-color-text-on-surface-strong);height:18px;width:18px;line-height:18px}.x-table-container .x-table-topbar .x-table-download-button i{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled x-svg-icon{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled i{display:flex}.x-table-container .x-table{padding:4px 0}.x-table-container .x-table tr{height:80px}.x-table-container .x-table tr>th{padding:24px 16px;background:var(--x-color-background-surface);color:var(--x-color-text-on-surface-strong);font-weight:600;line-height:18px;overflow:auto}.x-table-container .x-table tr>th:before{display:none}.x-table-container .x-table tr>td{padding:12px 16px;color:var(--x-color-text-on-surface-strong)}.x-table-container .x-table tr:hover>td{background-color:var(--x-focus-subtle)!important}.x-table-container .x-table tr td:first-of-type,.x-table-container .x-table tr th:first-of-type{padding-left:24px}.x-table-container .x-table tr td:last-of-type,.x-table-container .x-table tr th:last-of-type{padding-right:24px}.x-table-container .x-table ::ng-deep .ant-table-pagination{justify-content:flex-start;padding:8px 24px}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-pagination-total-text{margin-right:auto}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-select-selector{box-sizing:border-box!important;min-width:100px;min-height:auto}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-select-selector .ant-select-selection-item{margin-top:0!important}.x-table-container .x-table-expandable-icon{display:none}.x-table-container .x-table-number-type{font-size:14px;line-height:22px;color:var(--x-color-text-on-surface-subtle)}.x-table-container .x-table-number-type a{display:block;font-weight:600;color:var(--x-color-text-on-surface-link)}.x-table-container .x-table-number-type a:hover{text-decoration:underline}.x-table-container .x-table-tag{font-size:14px;line-height:18px;padding:3px 8px;background:var(--x-color-system-subtle-grey);border:none}.x-table-loading{display:none}.x-table-spinner{padding:80px;text-align:center}.x-table-spinner .x-table-spinner-spinning i{font-size:48px;color:var(--x-color-primary-main)}.x-table-spinner p{margin:20px 0 0;color:var(--x-color-text-on-surface-subtle);font-weight:400;font-size:16px;line-height:20px}\n"], components: [{ type: i1.NzInputGroupComponent, selector: "nz-input-group", inputs: ["nzAddOnBeforeIcon", "nzAddOnAfterIcon", "nzPrefixIcon", "nzSuffixIcon", "nzSize", "nzSearch", "nzCompact", "nzAddOnBefore", "nzAddOnAfter", "nzPrefix", "nzSuffix"], exportAs: ["nzInputGroup"] }, { type: i3.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { type: i3$1.NzSpinComponent, selector: "nz-spin", inputs: ["nzIndicator", "nzSize", "nzTip", "nzDelay", "nzSimple", "nzSpinning"], exportAs: ["nzSpin"] }, { type: i4$1.NzTableComponent, selector: "nz-table", inputs: ["nzTableLayout", "nzShowTotal", "nzItemRender", "nzTitle", "nzFooter", "nzNoResult", "nzPageSizeOptions", "nzVirtualItemSize", "nzVirtualMaxBufferPx", "nzVirtualMinBufferPx", "nzVirtualForTrackBy", "nzLoadingDelay", "nzPageIndex", "nzPageSize", "nzTotal", "nzWidthConfig", "nzData", "nzPaginationPosition", "nzScroll", "nzPaginationType", "nzFrontPagination", "nzTemplateMode", "nzShowPagination", "nzLoading", "nzOuterBordered", "nzLoadingIndicator", "nzBordered", "nzSize", "nzShowSizeChanger", "nzHideOnSinglePage", "nzShowQuickJumper", "nzSimple"], outputs: ["nzPageSizeChange", "nzPageIndexChange", "nzQueryParams", "nzCurrentPageDataChange"], exportAs: ["nzTable"] }, { type: i4$1.NzTheadComponent, selector: "thead:not(.ant-table-thead)", outputs: ["nzSortOrderChange"] }, { type: i4$1.NzThSelectionComponent, selector: "th[nzSelections],th[nzChecked],th[nzShowCheckbox],th[nzShowRowSelection]", inputs: ["nzSelections", "nzChecked", "nzDisabled", "nzIndeterminate", "nzShowCheckbox", "nzShowRowSelection"], outputs: ["nzCheckedChange"] }, { type: i4$1.NzTbodyComponent, selector: "tbody" }, { type: i4$1.NzTdAddOnComponent, selector: "td[nzChecked], td[nzDisabled], td[nzIndeterminate], td[nzIndentSize], td[nzExpand], td[nzShowExpand], td[nzShowCheckbox]", inputs: ["nzChecked", "nzDisabled", "nzIndeterminate", "nzIndentSize", "nzShowExpand", "nzShowCheckbox", "nzExpand"], outputs: ["nzCheckedChange", "nzExpandChange"] }, { type: CustomDataTableCellComponent, selector: "x-custom-data-table-cell", inputs: ["column", "record"] }], directives: [{ type: i8.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i1.NzInputGroupWhitSuffixOrPrefixDirective, selector: "nz-input-group[nzSuffix], nz-input-group[nzPrefix]" }, { type: i1.NzInputDirective, selector: "input[nz-input],textarea[nz-input]", inputs: ["nzBorderless", "nzSize", "disabled"], exportAs: ["nzInput"] }, { type: i7.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i7.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i7.FormControlDirective, selector: "[formControl]", inputs: ["disabled", "formControl", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i9.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i9$1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { type: i4$1.NzTrDirective, selector: "tr:not([mat-row]):not([mat-header-row]):not([nz-table-measure-row]):not([nzExpand]):not([nz-table-fixed-row])" }, { type: i4$1.NzTableCellDirective, selector: "th:not(.nz-disable-th):not([mat-cell]), td:not(.nz-disable-td):not([mat-cell])" }, { type: i4$1.NzThMeasureDirective, selector: "th", inputs: ["nzWidth", "colspan", "colSpan", "rowspan", "rowSpan"] }, { type: i5.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: DataTableComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'x-data-table',
                    templateUrl: './data-table.component.html',
                    styleUrls: ['./data-table.component.scss'],
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { columns: [{
                type: Input
            }], records: [{
                type: Input
            }], showDownload: [{
                type: Input
            }], downloadFile: [{
                type: Input
            }], displaySizeOptions: [{
                type: Input
            }], totalRecordsCount: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], label: [{
                type: Input
            }], loading: [{
                type: Input
            }], selectable: [{
                type: Input
            }], selectedRecordsSet: [{
                type: Input
            }], readonly: [{
                type: Input
            }], customCellTemplateRef: [{
                type: Input
            }], fetchRecords: [{
                type: Output
            }], selectRecord: [{
                type: Output
            }] } });

class UmbrellaDataTableModule {
}
UmbrellaDataTableModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaDataTableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UmbrellaDataTableModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaDataTableModule, declarations: [DataTableComponent, CustomDataTableCellComponent], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        NzButtonModule,
        NzDropDownModule,
        NzGridModule,
        NzIconModule,
        NzInputModule,
        NzPaginationModule,
        NzSpinModule,
        NzSwitchModule,
        NzTableModule], exports: [DataTableComponent] });
UmbrellaDataTableModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaDataTableModule, imports: [[
            CommonModule,
            FormsModule,
            ReactiveFormsModule,
            NzButtonModule,
            NzDropDownModule,
            NzGridModule,
            NzIconModule,
            NzInputModule,
            NzPaginationModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaDataTableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [DataTableComponent, CustomDataTableCellComponent],
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        NzButtonModule,
                        NzDropDownModule,
                        NzGridModule,
                        NzIconModule,
                        NzInputModule,
                        NzPaginationModule,
                        NzSpinModule,
                        NzSwitchModule,
                        NzTableModule,
                    ],
                    exports: [DataTableComponent],
                }]
        }] });

class HeaderComponent {
    constructor() {
        this.title = '';
        this.subTitle = '';
    }
}
HeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: HeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
HeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: HeaderComponent, selector: "x-header", inputs: { title: "title", subTitle: "subTitle", tags: "tags", primaryButton: "primaryButton", secondaryButtons: "secondaryButtons", ellipsisDropdownItems: "ellipsisDropdownItems", breadcrumbItems: "breadcrumbItems", navRoutes: "navRoutes" }, ngImport: i0, template: "<nz-page-header class=\"x-app-header\">\r\n  <!-- breadcrumbs -->\r\n  <nz-breadcrumb *ngIf=\"breadcrumbItems?.length\"\r\n      nzSeparator=\">\"\r\n      nz-page-header-breadcrumb>\r\n    <nz-breadcrumb-item *ngFor=\"let breadcrumb of breadcrumbItems\">\r\n      <a *ngIf=\"breadcrumb.routerLink\"\r\n          [routerLink]=\"breadcrumb.routerLink\">\r\n        {{ breadcrumb.name }}\r\n      </a>\r\n      <ng-container *ngIf=\"!breadcrumb.routerLink\">{{ breadcrumb.name }}</ng-container>\r\n    </nz-breadcrumb-item>\r\n  </nz-breadcrumb>\r\n\r\n  <!--title-->\r\n  <nz-page-header-title>{{ title }}</nz-page-header-title>\r\n\r\n  <!--subtitle-->\r\n  <nz-page-header-subtitle *ngIf=\"subTitle\">{{ subTitle }}</nz-page-header-subtitle>\r\n\r\n  <!--tags-->\r\n  <nz-page-header-tags *ngIf=\"tags?.length\">\r\n    <nz-tag *ngFor=\"let tag of tags\"\r\n        nzColor=\"{{ tag?.nzStatusColor || tag?.color }}\">\r\n      {{ tag?.text }}\r\n    </nz-tag>\r\n  </nz-page-header-tags>\r\n\r\n  <!-- action buttons and dropdown items-->\r\n  <nz-page-header-extra>\r\n    <ng-container *ngIf=\"secondaryButtons?.length\">\r\n      <button *ngFor=\"let secondaryButton of secondaryButtons\"\r\n          nz-button\r\n          (click)=\"secondaryButton.action()\"\r\n          [disabled]=\"secondaryButton.disabled\">\r\n        <i *ngIf=\"secondaryButton.nzIconName\"\r\n            nz-icon\r\n            [nzType]=\"secondaryButton.nzIconName\"></i>\r\n        {{ secondaryButton.text }}\r\n      </button>\r\n    </ng-container>\r\n    <button *ngIf=\"primaryButton\"\r\n        nz-button\r\n        nzType=\"primary\"\r\n        (click)=\"primaryButton.action()\"\r\n        [disabled]=\"primaryButton.disabled\">\r\n      <i *ngIf=\"primaryButton.nzIconName\"\r\n          nz-icon\r\n          [nzType]=\"primaryButton.nzIconName\"></i>\r\n      {{ primaryButton?.text }}\r\n    </button>\r\n    <ng-container *ngIf=\"ellipsisDropdownItems?.length\">\r\n      <button nz-button\r\n          nzNoAnimation\r\n          nz-dropdown\r\n          [nzDropdownMenu]=\"menu\"\r\n          style=\"border: none; padding: 0\">\r\n        <i nz-icon\r\n            nzType=\"ellipsis\"\r\n            nzTheme=\"outline\"\r\n            style=\"font-size: 20px; vertical-align: top\"></i>\r\n      </button>\r\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\r\n        <ul nz-menu>\r\n          <li *ngFor=\"let dropdownItem of ellipsisDropdownItems\"\r\n              nz-menu-item>\r\n            {{ dropdownItem.text }}\r\n          </li>\r\n        </ul>\r\n      </nz-dropdown-menu>\r\n    </ng-container>\r\n  </nz-page-header-extra>\r\n\r\n  <!-- navigation -->\r\n  <nz-page-header-content>\r\n    <ng-content></ng-content>\r\n    <div *ngIf=\"navRoutes?.length\">\r\n      <nz-tabset nzLinkRouter>\r\n        <nz-tab *ngFor=\"let route of navRoutes\">\r\n          <a [attr.data-testid]=\"route.id\"\r\n              *nzTabLink\r\n              nz-tab-link\r\n              [routerLink]=\"[route.path]\"\r\n              routerLinkActive=\"active\">\r\n            {{ route.name }}\r\n          </a>\r\n        </nz-tab>\r\n      </nz-tabset>\r\n      <ng-template #extraTemplate></ng-template>\r\n    </div>\r\n  </nz-page-header-content>\r\n</nz-page-header>\r\n", styles: [".x-app-header{background:rgba(255,255,255,.57);border-bottom:1px solid rgba(0,0,0,.15);padding:24px 24px 0;display:flex;flex-direction:column;position:relative}.x-app-header:before{content:\"\";background-image:url(/assets/fleet-manager/pattern.svg);background-repeat:no-repeat;background-position:right;width:100%;height:100%;position:absolute;right:0;top:0;opacity:.18;pointer-events:none}.x-app-header .ant-page-header-heading-title{font-family:\"Shell\";font-weight:600;font-size:32px;line-height:40px;margin-left:20px}.ant-tag{border-radius:12px}\n"], components: [{ type: i1$1.NzPageHeaderComponent, selector: "nz-page-header", inputs: ["nzBackIcon", "nzGhost", "nzTitle", "nzSubtitle"], outputs: ["nzBack"], exportAs: ["nzPageHeader"] }, { type: i2$1.NzBreadCrumbComponent, selector: "nz-breadcrumb", inputs: ["nzAutoGenerate", "nzSeparator", "nzRouteLabel", "nzRouteLabelFn"], exportAs: ["nzBreadcrumb"] }, { type: i2$1.NzBreadCrumbItemComponent, selector: "nz-breadcrumb-item", inputs: ["nzOverlay"], exportAs: ["nzBreadcrumbItem"] }, { type: i3$2.NzTagComponent, selector: "nz-tag", inputs: ["nzMode", "nzChecked", "nzColor"], outputs: ["nzOnClose", "nzCheckedChange"], exportAs: ["nzTag"] }, { type: i3.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { type: i4.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }, { type: i6.NzTabSetComponent, selector: "nz-tabset", inputs: ["nzTabPosition", "nzCanDeactivate", "nzAddIcon", "nzTabBarStyle", "nzType", "nzSize", "nzAnimated", "nzTabBarGutter", "nzHideAdd", "nzCentered", "nzHideAll", "nzLinkRouter", "nzLinkExact", "nzSelectedIndex", "nzTabBarExtraContent"], outputs: ["nzSelectChange", "nzSelectedIndexChange", "nzTabListScroll", "nzClose", "nzAdd"], exportAs: ["nzTabset"] }, { type: i6.NzTabComponent, selector: "nz-tab", inputs: ["nzTitle", "nzClosable", "nzCloseIcon", "nzDisabled", "nzForceRender"], outputs: ["nzSelect", "nzDeselect", "nzClick", "nzContextmenu"], exportAs: ["nzTab"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$1.NzPageHeaderBreadcrumbDirective, selector: "nz-breadcrumb[nz-page-header-breadcrumb]", exportAs: ["nzPageHeaderBreadcrumb"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i8$1.RouterLinkWithHref, selector: "a[routerLink],area[routerLink]", inputs: ["routerLink", "target", "queryParams", "fragment", "queryParamsHandling", "preserveFragment", "skipLocationChange", "replaceUrl", "state", "relativeTo"] }, { type: i1$1.NzPageHeaderTitleDirective, selector: "nz-page-header-title, [nz-page-header-title]", exportAs: ["nzPageHeaderTitle"] }, { type: i1$1.NzPageHeaderSubtitleDirective, selector: "nz-page-header-subtitle, [nz-page-header-subtitle]", exportAs: ["nzPageHeaderSubtitle"] }, { type: i1$1.NzPageHeaderTagDirective, selector: "nz-page-header-tags, [nz-page-header-tags]", exportAs: ["nzPageHeaderTags"] }, { type: i1$1.NzPageHeaderExtraDirective, selector: "nz-page-header-extra, [nz-page-header-extra]", exportAs: ["nzPageHeaderExtra"] }, { type: i9.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i8.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i9$1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { type: i4.NzDropdownButtonDirective, selector: "[nz-button][nz-dropdown]" }, { type: i4.NzDropDownDirective, selector: "[nz-dropdown]", inputs: ["nzDropdownMenu", "nzTrigger", "nzMatchWidthElement", "nzHasBackdrop", "nzBackdrop", "nzClickHide", "nzDisabled", "nzVisible", "nzOverlayClassName", "nzOverlayStyle", "nzPlacement"], outputs: ["nzVisibleChange"], exportAs: ["nzDropdown"] }, { type: i10.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { type: i10.NzMenuItemDirective, selector: "[nz-menu-item]", inputs: ["nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter", "nzPaddingLeft"], exportAs: ["nzMenuItem"] }, { type: i1$1.NzPageHeaderContentDirective, selector: "nz-page-header-content, [nz-page-header-content]", exportAs: ["nzPageHeaderContent"] }, { type: i6.NzTabLinkTemplateDirective, selector: "ng-template[nzTabLink]", exportAs: ["nzTabLinkTemplate"] }, { type: i6.NzTabLinkDirective, selector: "a[nz-tab-link]", exportAs: ["nzTabLink"] }, { type: i8$1.RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "routerLinkActive"], exportAs: ["routerLinkActive"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: HeaderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'x-header',
                    templateUrl: './header.component.html',
                    styleUrls: ['./header.component.scss'],
                }]
        }], propDecorators: { title: [{
                type: Input
            }], subTitle: [{
                type: Input
            }], tags: [{
                type: Input
            }], primaryButton: [{
                type: Input
            }], secondaryButtons: [{
                type: Input
            }], ellipsisDropdownItems: [{
                type: Input
            }], breadcrumbItems: [{
                type: Input
            }], navRoutes: [{
                type: Input
            }] } });

class UmbrellaHeaderModule {
}
UmbrellaHeaderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UmbrellaHeaderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaHeaderModule, declarations: [HeaderComponent], imports: [CommonModule,
        RouterModule,
        NzPageHeaderModule,
        NzTabsModule,
        NzBreadCrumbModule,
        NzTagModule,
        NzButtonModule,
        NzDropDownModule,
        NzIconModule], exports: [HeaderComponent] });
UmbrellaHeaderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaHeaderModule, imports: [[
            CommonModule,
            RouterModule,
            NzPageHeaderModule,
            NzTabsModule,
            NzBreadCrumbModule,
            NzTagModule,
            NzButtonModule,
            NzDropDownModule,
            NzIconModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [HeaderComponent],
                    imports: [
                        CommonModule,
                        RouterModule,
                        NzPageHeaderModule,
                        NzTabsModule,
                        NzBreadCrumbModule,
                        NzTagModule,
                        NzButtonModule,
                        NzDropDownModule,
                        NzIconModule,
                    ],
                    exports: [HeaderComponent],
                }]
        }] });

class FooterComponent {
    constructor() { }
    ngOnInit() { }
}
FooterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: FooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FooterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: FooterComponent, selector: "x-footer", inputs: { primaryButton: "primaryButton", secondaryButtons: "secondaryButtons" }, ngImport: i0, template: "<div nz-col\r\n    nzJustify=\"end\">\r\n  <div nz-row\r\n      nzJustify=\"end\"\r\n      class=\"x-app-footer-logo-container\">\r\n    <div nz-col\r\n        class=\"x-app-footer-logo\"></div>\r\n  </div>\r\n  <div *ngIf=\"primaryButton || secondaryButtons\"\r\n      nz-row\r\n      nzJustify=\"end\"\r\n      class=\"x-app-footer-buttons\">\r\n    <ng-container *ngIf=\"secondaryButtons?.length\">\r\n      <button *ngFor=\"let secondaryButton of secondaryButtons\"\r\n          nz-button\r\n          (click)=\"secondaryButton.action()\"\r\n          [disabled]=\"secondaryButton.disabled\">\r\n        <i *ngIf=\"secondaryButton.nzIconName\"\r\n            nz-icon\r\n            [nzType]=\"secondaryButton.nzIconName\"></i>\r\n        {{ secondaryButton.text }}\r\n      </button>\r\n    </ng-container>\r\n    <button *ngIf=\"primaryButton\"\r\n        nz-button\r\n        nzType=\"primary\"\r\n        (click)=\"primaryButton.action()\"\r\n        [disabled]=\"primaryButton.disabled\">\r\n      <i *ngIf=\"primaryButton.nzIconName\"\r\n          nz-icon\r\n          [nzType]=\"primaryButton.nzIconName\"></i>\r\n      {{ primaryButton?.text }}\r\n    </button>\r\n  </div>\r\n</div>\r\n", styles: [":host{background:var(--x-color-background-base);min-height:40px;bottom:0;position:relative}.x-app-footer-logo-container{background:var(--x-color-background-base)}.x-app-footer-logo{background-image:url(/assets/fleet-manager/shell-recharge.svg);background-repeat:no-repeat;background-size:contain;width:140px;min-height:40px;margin:24px 24px 12px 0}.x-app-footer-buttons{background:#fff;padding:12px}.ant-btn{margin-left:12px!important}\n"], components: [{ type: i3.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }], directives: [{ type: i2$2.NzColDirective, selector: "[nz-col],nz-col,nz-form-control,nz-form-label", inputs: ["nzFlex", "nzSpan", "nzOrder", "nzOffset", "nzPush", "nzPull", "nzXs", "nzSm", "nzMd", "nzLg", "nzXl", "nzXXl"], exportAs: ["nzCol"] }, { type: i2$2.NzRowDirective, selector: "[nz-row],nz-row,nz-form-item", inputs: ["nzAlign", "nzJustify", "nzGutter"], exportAs: ["nzRow"] }, { type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i9.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { type: i8.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { type: i9$1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzRotate", "nzSpin", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: FooterComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'x-footer',
                    templateUrl: './footer.component.html',
                    styleUrls: ['./footer.component.scss'],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { primaryButton: [{
                type: Input
            }], secondaryButtons: [{
                type: Input
            }] } });

class UmbrellaFooterModule {
}
UmbrellaFooterModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaFooterModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UmbrellaFooterModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaFooterModule, declarations: [FooterComponent], imports: [CommonModule, NzGridModule, NzButtonModule, NzIconModule], exports: [FooterComponent] });
UmbrellaFooterModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaFooterModule, imports: [[CommonModule, NzGridModule, NzButtonModule, NzIconModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaFooterModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [FooterComponent],
                    imports: [CommonModule, NzGridModule, NzButtonModule, NzIconModule],
                    exports: [FooterComponent],
                }]
        }] });

/* Ant icon definitions */
const icons = [EditOutline, PlusOutline, DeleteOutline, WarningOutline];
class UmbrellaLibraryModule {
}
UmbrellaLibraryModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UmbrellaLibraryModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryModule, declarations: [UmbrellaLibraryComponent], imports: [
        /* Angular Modules */
        CommonModule,
        ReactiveFormsModule,
        /* Umbrella Modules */
        UmbrellaHeaderModule,
        UmbrellaFooterModule,
        UmbrellaDataTableModule,
        /* Ant Modules */
        NzAnchorModule,
        NzBreadCrumbModule,
        NzButtonModule,
        NzCardModule,
        NzCascaderModule,
        NzCollapseModule,
        NzDividerModule,
        NzDrawerModule,
        NzFormModule,
        NzGridModule,
        NzIconModule, i9$1.NzIconModule, NzInputModule,
        NzInputNumberModule,
        NzMessageModule,
        NzModalModule,
        NzPageHeaderModule,
        NzPaginationModule,
        NzRadioModule,
        NzResultModule,
        NzSelectModule,
        NzSpaceModule,
        NzSpinModule,
        NzSwitchModule,
        NzTableModule,
        NzTabsModule,
        NzTagModule,
        NzToolTipModule,
        NzTypographyModule], exports: [
        /* Angular Modules */
        CommonModule,
        ReactiveFormsModule,
        /* Umbrella Modules */
        UmbrellaHeaderModule,
        UmbrellaFooterModule,
        UmbrellaDataTableModule,
        /* Ant Modules */
        NzAnchorModule,
        NzBreadCrumbModule,
        NzButtonModule,
        NzCardModule,
        NzCascaderModule,
        NzCollapseModule,
        NzDividerModule,
        NzDrawerModule,
        NzFormModule,
        NzGridModule,
        NzIconModule,
        NzInputModule,
        NzInputNumberModule,
        NzMessageModule,
        NzModalModule,
        NzPageHeaderModule,
        NzPaginationModule,
        NzRadioModule,
        NzResultModule,
        NzSelectModule,
        NzSpaceModule,
        NzSpinModule,
        NzSwitchModule,
        NzTableModule,
        NzTabsModule,
        NzTagModule,
        NzToolTipModule,
        NzTypographyModule] });
UmbrellaLibraryModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryModule, imports: [[
            /* Angular Modules */
            CommonModule,
            ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            NzAnchorModule,
            NzBreadCrumbModule,
            NzButtonModule,
            NzCardModule,
            NzCascaderModule,
            NzCollapseModule,
            NzDividerModule,
            NzDrawerModule,
            NzFormModule,
            NzGridModule,
            NzIconModule,
            NzIconModule.forChild(icons),
            NzInputModule,
            NzInputNumberModule,
            NzMessageModule,
            NzModalModule,
            NzPageHeaderModule,
            NzPaginationModule,
            NzRadioModule,
            NzResultModule,
            NzSelectModule,
            NzSpaceModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule,
            NzTabsModule,
            NzTagModule,
            NzToolTipModule,
            NzTypographyModule,
        ], 
        /* Angular Modules */
        CommonModule,
        ReactiveFormsModule,
        /* Umbrella Modules */
        UmbrellaHeaderModule,
        UmbrellaFooterModule,
        UmbrellaDataTableModule,
        /* Ant Modules */
        NzAnchorModule,
        NzBreadCrumbModule,
        NzButtonModule,
        NzCardModule,
        NzCascaderModule,
        NzCollapseModule,
        NzDividerModule,
        NzDrawerModule,
        NzFormModule,
        NzGridModule,
        NzIconModule,
        NzInputModule,
        NzInputNumberModule,
        NzMessageModule,
        NzModalModule,
        NzPageHeaderModule,
        NzPaginationModule,
        NzRadioModule,
        NzResultModule,
        NzSelectModule,
        NzSpaceModule,
        NzSpinModule,
        NzSwitchModule,
        NzTableModule,
        NzTabsModule,
        NzTagModule,
        NzToolTipModule,
        NzTypographyModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: UmbrellaLibraryModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UmbrellaLibraryComponent],
                    imports: [
                        /* Angular Modules */
                        CommonModule,
                        ReactiveFormsModule,
                        /* Umbrella Modules */
                        UmbrellaHeaderModule,
                        UmbrellaFooterModule,
                        UmbrellaDataTableModule,
                        /* Ant Modules */
                        NzAnchorModule,
                        NzBreadCrumbModule,
                        NzButtonModule,
                        NzCardModule,
                        NzCascaderModule,
                        NzCollapseModule,
                        NzDividerModule,
                        NzDrawerModule,
                        NzFormModule,
                        NzGridModule,
                        NzIconModule,
                        NzIconModule.forChild(icons),
                        NzInputModule,
                        NzInputNumberModule,
                        NzMessageModule,
                        NzModalModule,
                        NzPageHeaderModule,
                        NzPaginationModule,
                        NzRadioModule,
                        NzResultModule,
                        NzSelectModule,
                        NzSpaceModule,
                        NzSpinModule,
                        NzSwitchModule,
                        NzTableModule,
                        NzTabsModule,
                        NzTagModule,
                        NzToolTipModule,
                        NzTypographyModule,
                    ],
                    exports: [
                        /* Angular Modules */
                        CommonModule,
                        ReactiveFormsModule,
                        /* Umbrella Modules */
                        UmbrellaHeaderModule,
                        UmbrellaFooterModule,
                        UmbrellaDataTableModule,
                        /* Ant Modules */
                        NzAnchorModule,
                        NzBreadCrumbModule,
                        NzButtonModule,
                        NzCardModule,
                        NzCascaderModule,
                        NzCollapseModule,
                        NzDividerModule,
                        NzDrawerModule,
                        NzFormModule,
                        NzGridModule,
                        NzIconModule,
                        NzInputModule,
                        NzInputNumberModule,
                        NzMessageModule,
                        NzModalModule,
                        NzPageHeaderModule,
                        NzPaginationModule,
                        NzRadioModule,
                        NzResultModule,
                        NzSelectModule,
                        NzSpaceModule,
                        NzSpinModule,
                        NzSwitchModule,
                        NzTableModule,
                        NzTabsModule,
                        NzTagModule,
                        NzToolTipModule,
                        NzTypographyModule,
                    ],
                }]
        }] });

/*
 * Public API Surface of umbrella-library
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DataTableColumnFormatType, DataTableComponent, FooterComponent, HeaderComponent, ResponseStatus, UmbrellaDataTableModule, UmbrellaFooterModule, UmbrellaHeaderModule, UmbrellaLibraryComponent, UmbrellaLibraryModule, UmbrellaLibraryService };
//# sourceMappingURL=umbrella-library.js.map
